Subject: Re: Re-queueing of skb in vlan_skb_recv

From: Al Viro <[email-masked]>
Date: Fri, 11 Apr 2008 13:53:13 +0100

On Fri, Apr 11, 2008 at 02:46:35PM +0200, Patrick McHardy wrote:
> Brian Oostenbrink wrote:
> >In vlan_skb_recv, packets are generally stripped of their vlan header,
> >and then re-queued via netif_rx().  Is there a reason for re-queuing
> >these instead of calling netif_receive_skb() directly?  On our system
> >(an embedded linux router), this re-queuing has a significant
> >performance penalty.
> 
> Its done to save stack space. There's currently a discussion
> about making loopback use netif_receive_skb in case enough
> stack is still available. Once that patch gets merged I'll
> change VLAN in a similar way.

Another possibility would be to allow ->func() of packet_type to return an
skb for reprocessing...